#! perl

$lc = 0;
while($in = <>) {
    if($in =~ /(\d{5}) ?(\d{5})/) {
	$password[$lc] = $1.$2;
	++$lc;
	#print "found\n";
    } else {
	#print "not found\n";
	print $in;
	$lc = 0;
    }
    if($lc > 2) {
	$lc = 0;

	for $idx(0..2){
	    $line[$idx] = join("", reverse(split("", $password[$idx])));
	    $hx = sprintf("%08x", $line[$idx]);
	    #print $hx, "\n";
	    for ($byte = $idx * 4; $byte < $idx * 4 + 4; ++$byte) {
		$byte[$byte] = substr($hx, 2*($byte%4),2);
	    }
	    
	}

	#print join(" ", @byte), "\n";
	$chksm = 0;
	for $byteval (@byte[0,1,2,3,4,5,6,7,9,10,11]) {
	    $chksm += hex($byteval);
	    #print "$chksm ";
	}
	$chksm = $chksm & 255;
#	$chksm = unpack("%8C", @byte[0,1,2,3,4,5,6,7,9,10,11]);
	if ($chksm != hex($byte[8])) {printf( "bad checksum %x %s\n", $chksm, $byte[8]);}
#checksum is byte[8]
#dimensions is byte[9] in hex

	$h = substr($byte[9], 1);
	$v = substr($byte[9], 0, 1);

	#print "h ", $h, " v ", $v, "\n";

	#printf("%s %x\n", unpack("B32", $line[0]), $line[0]);
	#printf("%s %x\n", unpack("B32", $line[1]),$line[1]);
	#printf("%s %x\n", unpack("B32", $line[2]),$line[2]);

	$count = 0;
	#print "-------------------------------------\n";
	for $idx (3, 2, 1, 0, 7, 6, 5, 4) {
#    printf("%x %s\n", hex($byte[$idx]), unpack("B8", hex($byte[$idx])));
	    if($count <= 2) {
		print substr($password[$count],0,5), " ",
		    substr($password[$count],5), " ";
	    } else {
		print "            ";
	    }
	    print substr(&binary(hex($byte[$idx])), 0, $h*2), "\n";
	    ++$count;
	    last if $count >= $v;
	} # for $idx ...
	print "-------------------------------------\n";
    } # $lc >= 2
}

sub binary {
    my $x;
    my $o;
    my $in = shift;
    $o = "";
    for $x (0..7) {
	if (($in) & 1<<$x) {
	    $o = $o . "@ ";
	} else {
	    $o = $o . "- ";
	}
    }
    $o;
}
	 
